Open Infrastructure - Task #7890

test conntrack sync
03/30/2020 08:20 AM - Jin-Guk Kwon

Status: Closed
Priority: Normal
Assignee: Jin-Guk Kwon
Category:

Target version:
PM Check date:

Start date:
Due date:

% Done:

Estimated time:

03/30/2020

80%
0.00 hour

Description
test conntrack sync on alpine

History

#1 - 03/30/2020 10:51 AM - Jin-Guk Kwon

router1Fw)

host1

router2ewz)

#2 - 03/30/2020 10:52 AM - Jin-Guk Kwon

- test conntrack sync on debian

1. install conntrack, conntrackd at router1,2

apt install conntrack conntrackd

2. config conntrackd file as notrack mode at router1,2
3. set router at host1,2

- host1

ip -6 route add host2 via routerl

- host2

ip -6 route add hostl via router2

4. set ip6table at router 1

sysctl -w net.ipv6.conf.all.forwarding=1
ipé6tables —-P FORWARD DROP

ipé6tables —-A FORWARD -s hostl -3j ACCEPT
ip6tables -A FORWARD -s host2 -3 ACCEPT

ip6tables —-A FORWARD -m state —--state NEW,RELATED,ESTABLISHED -j ACCEPT
5. test packet
- host1

#iperf3 -c 2a0a:e5c0:2:12:0:f0ff:fea%9:c47f -t 10000
Connecting to host 2ala:e5c0:2:12:0:f0ff:fea%:c47f, port 5201
5] local 2a0a:eb5c0:2:12:0:f0ff:fea%9:c47b port 51314 connected to 2ala:eb5c0:2:12:0:£f0ff:fea9:c47f port 5201

[

[ ID] Interval Transfer Bitrate Retr Cwnd

[ 5] 0.00-1.00 sec 121 MBytes 1.02 Gbits/sec 0 3.01 MBytes
[ 5] 1.00-2.00 sec 118 MBytes 986 Mbits/sec 0 3.01 MBytes
[ 5] 2.00-3.00 sec 119 MBytes 996 Mbits/sec 0 3.01 MBytes
- host2

#iperf3 -s

Server listening on 5201

Accepted connection from 2a0a:e5c0:2:12:0:£f0ff:fea9:c47b, port 51312

[ 5] local 2a0a:e5c0:2:12:0:£f0ff:fea%9:c47f port 5201 connected to 2a0a:e5c0:2:12:0:f0ff:fea9%:c47b port 51314
[ ID] Interval Transfer Bitrate

[ 5] 0.00-1.00 sec 118 MBytes 990 Mbits/sec

[ 5] 1.00-2.00 sec 118 MBytes 990 Mbits/sec

6. check conntrack table
- router1

test-debian-conntl:/etc/conntrackd# conntrackd -i

tcp 6 SYN_RECV src=2a0a:e5c0:2:12:0:f0ff:fea9%9:c47b dst=2a0a:e5c0:2:12:0:£f0ff:fea%:c47f sport=51312 dport=
5201 src=2al0a:e5c0:2:12:0:£f0ff:fea%9:c47f dst=2al0a:e5c0:2:12:0:£0ff:fea9:c47b sport=5201 dport=51312 [active si
nce 17s]

test-debian-conntl:/etc/conntrackd#

-router2

test-debian-connt2:/etc/conntrackd# ./primary-backup.sh backup

test-debian-connt2:/etc/conntrackd# conntrackd -e

tcp 6 ESTABLISHED src=2ala:e5c0:2:12:0:f0ff:fea%9:c47b dst=2a0a:e5c0:2:12:0:f0ff:fea%9:c47f sport=51314 dpo

rt=5201 [ASSURED] [active since 71s]
test-debian-connt2:

#3 - 03/30/2020 11:03 AM - Jin-Guk Kwon

- test conntrack sync on alpine

1. install conntrack, conntrackd at router1,2

apk add conntrack-tools

2. config conntrackd file as notrack mode at router1,2
3. set router at host1,2

- host1

ip -6 route add host2 wvia routerl

- host2

ip -6 route add hostl via routerl

4. set ip6table at router 1

sysctl -w net.ipv6.conf.all.forwarding=1
ip6tables —-P FORWARD DROP

ip6tables —-A FORWARD -s hostl —-j ACCEPT
ipé6tables —-A FORWARD -s host2 -3j ACCEPT

ip6tables —-A FORWARD -m state --state NEW,RELATED,ESTABLISHED -j ACCEPT

5. check conntrack table
- router1

test-alpine-conntl:/etc/conntrackd# conntrackd -i
[ERROR] inet_pton(): IPv6 unsupported!

#4 - 03/30/2020 11:14 AM - Jin-Guk Kwon

- not support IPv6 on alpine package
on debian

[11:05:26] test-debian-conntl:/lib/modules/4.9.0-12-amd64# lsmod | grep nf_conn

nf_conntrack_ipveé 20480 1

nf_defrag_ipvé6 16384 1 nf_conntrack_ipvé

nf_conntrack_netlink 40960 O

nf_conntrack 114688 3 nf_conntrack_ipvé6,nf_conntrack_netlink, xt_conntrack
nfnetlink 16384 8 nf_conntrack_netlink,nf_tables

[11:05:47] test-debian-conntl:/lib/modules/4.9.0-12-amd64#

on alpine

[07:39] test-alpine-connt2:/etc/conntrackd# lsmod | grep nf_conn

nf_conntrack_netlink 53248 0

nf_conntrack 143360 1 nf_conntrack_netlink
nf_defrag_ipv4 16384 1 nf_conntrack
libcrc32c 16384 1 nf_conntrack
nfnetlink 16384 7 nf_conntrack_netlink
nf_defrag_ipvé6 16384 2 nf_conntrack,ipvé

[11:07] test-alpine-connt2:/etc/conntrackd#
--> there is no nf_conntrack_ipvé

- check kernel option
on debian

[12:48:12] test-debian-conntl:/lib/modules/4.9.0-12-amd64# grep '~CONFIG_NF_CONNTRACK*' /boot/config-"$ (uname
-r)"

CONFIG_NF_CONNTRACK=m

CONFIG_NF_CONNTRACK_IPV4=m

CONFIG_NF_CONNTRACK_IPV6=m

[10:30:29] test-debian-conntl:/lib/modules/4.9.0-12-amd64#

on alpine

[11:10] test-alpine-connt2:/boot# grep '~CONFIG_NF_CONNTRACK*' /boot/config-virt
CONFIG_NF_CONNTRACK=m

CONFIG_NF_CONNTRACK_TFTP=m

[11:10] test-alpine-connt2:/boot#

- check module alias
on debian

[09:39:48] test-debian-conntl:/lib/modules/4.9.0-12-amd64# cat modules.alias | grep conntrack
alias ip_conntrack_proto_sctp nf_conntrack_proto_sctp

alias ip_conntrack nf_conntrack_ipv4

alias nf_conntrack-2 nf_conntrack_ipv4

alias nf_conntrack-10 nf_conntrack_ipv6

[09:54:37] test-debian-conntl:/lib/modules/4.9.0-12-amd64#

on alpine

[11:13] test-alpine-connt2:/lib/modules/5.4.12-1-virt# cat modules.alias | grep conntrack
alias nf_conntrack-10 nf_conntrack
alias nf_conntrack-2 nf_conntrack

alias ipt_conntrack xt_conntrack
[11:13] test-alpine-connt2:/lib/modules/5.4.12-1-virt#

#5 - 03/30/2020 11:20 AM - Jin-Guk Kwon

- install conntrack-tools from latest source

git clone git://git.netfilter.org/conntrack-tools

apk add autoconf automake libtool gcc g++ make
apk add linux-headers libnfnetlink-dev libnetfilter_conntrack-dev bison flex libmnl-dev libnetfilter_cttimeout

—dev libnetfilter_cthelper-dev libnetfilter_queue-dev libtirpc-dev

cd conntrack-tools/
./autogen.sh

./configure —prefix=/usr
make

make insatll

mkdir -p /etc/conntrackd
cd /etc/conntrackd

vi conntrackd.conf

apk add ipé6tables

-->it works

#6 - 03/30/2020 11:23 AM - Jin-Guk Kwon
- % Done changed from 0 to 80

6. test packet
- host1

#iperf3 -c 2a0a:e5c0:2:12:0:f0ff:fea%9:c47f -t 10000
Connecting to host 2a0a:e5c0:2:12:0:£f0ff:fea9%9:c47f, port 5201
5] local 2a0a:e5c0:2:12:0:f0ff:fea9%9:c47b port 51314 connected to 2ala:e5c0:2:12:0:f0ff:fea%9:c47f port 5201

[

[ ID] Interval Transfer

[ 5] 0.00-1.00 sec 121 MBytes
[ 5] 1.00-2.00 sec 118 MBytes
[ 5] 2.00-3.00 sec 119 MBytes
- host2

#iperf3 -s

Bitrate Retr Cwnd

1.02 Gbits/sec 0 3.01 MBytes
986 Mbits/sec 0 3.01 MBytes
996 Mbits/sec 0 3.01 MBytes

Server listening on 5201

Accepted connection from 2ala:e5c0:2:12:0:f0ff:fea%9:c47b, port 51312
[ 5] local 2a0a:eb5c0:2:12:0:£f0ff:fea%9:c47f port 5201 connected to 2ala:e5c0:2:12:0:f0ff:fea9%9:c47b port 51314

[ ID] Interval Transfer
[ 5] 0.00-1.00 sec 118 MBytes
[ 5] 1.00-2.00 sec 118 MBytes

7. check conntrack table
- router1

Bitrate

990 Mbits/sec
990 Mbits/sec

[12:49] test-alpine-conntl:/etc/conntrackd# conntrackd -i

[Fri Mar 27 12:49:38 2020] (pid=18086) [warning] getprotobyname () cannot find protocol
s

[Fri Mar 27 12:49:38 2020] (pid=18086) [warning] getprotobyname () cannot find protocol
s

[Fri Mar 27 12:49:38 2020] (pid=18086) [warning] getprotobyname () cannot find protocol
s

[Fri Mar 27 12:49:38 2020] (pid=18086) [warning] getprotobyname () cannot find protocol
tocols

tcp 6 SYN_RECV src=2ala:e5c0:2:12:0:£f0ff:fea9:c47b dst=2a0a:e5c0:2:12:0:£f0ff:fead

"SCTP' in /etc/protocol
"DCCP' in /etc/protocol
"ICMP' in /etc/protocol
“IPv6-ICMP' in /etc/pro

:c47f sport=51312 dport=

5201 src=2al0a:e5c0:2:12:0:£f0ff:fea9%9:c47f dst=2a0a:e5c0:2:12:0:£0ff:fea9:c47b sport=5201 dport=51312 [active si

nce 17s]

[12:49] test-alpine-conntl:/etc/conntrackd#

-router2

[12:50] test-alpine-connt2:/etc/conntrackd#

[12:50] test-alpine-connt2:/etc/conntrackd# conntrackd -e
[Fri Mar 27 12:51:02 2020] (pid=18102) [warning] getprotobyname () cannot
s

[Fri Mar 27 12:51:02 2020] (pid=18102) [warning] getprotobyname () cannot
s

[Fri Mar 27 12:51:02 2020] (pid=18102) [warning] getprotobyname () cannot
s

[Fri Mar 27 12:51:02 2020] (pid=18102) [warning] getprotobyname () cannot
tocols

tcp 6 ESTABLISHED src=2al0a:e5c0:2:12:0:f0ff:fea%:c47b dst=2ala:eb5c0:
rt=5201 [ASSURED] [active since 71s]

[12:51] test-alpine-connt2:

#7 - 03/30/2020 11:31 AM - Jin-Guk Kwon
- File conntrack.png added

#8 - 03/31/2020 01:17 PM - Jin-Guk Kwon

- conntrack-tools package issue

[12:32] test-alpine-conntl:~# conntrackd -d

find protocol
find protocol
find protocol

find protocol

"SCTP' in /etc/protocol

"DCCP' in /etc/protocol

"ICMP' in /etc/protocol

"IPv6-ICMP'

in /etc/pro

2:12:0:f0ff:fea%9:c47f sport=51314 dpo

[Tue Mar 31 12:32:58 2020] (pid=2954) [ERROR] inet_pton(): IPv6 unsupported!

[12:32] test-alpine-conntl:~#

pasckage-seuree-from-https://www.netfilter.org/projects/conntrack-tools/files/conntrack-tools$pkgver.

read_config yy.y file

udp_option : T_IPV6_DEST_ADDR T_IP

if (err == 0) {
dlog (LOG_WARNING, "%s is not a valid IPv6 address", $2);
break;

} else {
dlog (LOG_ERR, "inet_pton(): IPv6 unsupported!");

exit (EXIT_FAILURE) ;

- git source from http:/git.neffilter.org/conntrack-tools/tree/?h=conntrack-tools-1.4.5

read_config_yy.y file

udp_option : T_IPV6_DEST_ADDR T_IP

if (err == 0) {
dlog (LOG_WARNING, "%s is not a valid IPvé6 address", $2);
free ($2);
break;
} else if (err < 0) {
dlog (LOG_ERR, "inet_pton(): IPv6 unsupported!");

exit (EXIT_FAILURE) ;

#9 - 01/03/2024 06:31 PM - Nico Schottelius

- Status changed from In Progress to Closed

tar.bz2
